package DB::Test;

use Moose;

has 'schema' => (
    isa => 'DBIx::Class::Schema',
    is => 'ro',
    lazy_build => 1,
);

sub _build_schema {
    my $self = shift;
    return $self->schema_class->connect( @{ $self->connect_info } );
}

has 'schema_class' => (
    isa => 'Str',
    is => 'ro',
    lazy => 1,
    required => 1,
    default => 'Test::Schema',
);

has 'dbi' => (
    isa => 'Str',
    is => 'ro',
    required => 1,
);

has 'uid' => (
    isa => 'Str',
    is => 'ro',
    required => 1,
);

has 'pass' => (
    isa => 'Str',
    is => 'ro',
    required => 1,
);

has 'connect_info' => (
    isa => 'ArrayRef',
    is => 'ro',
    required => 1,
    lazy_build => 1,
); 

sub _build_connect_info {
    my $self = shift;
    return 
        [
            $self->dbi,$self->uid,$self->pass,
            { 
                on_connect_do => [ 
                    'SET search_path TO public',
                ],
            }
        ]

}

1;
